package cn.iocoder.yudao.module.shipment.dal.dataobject;

import lombok.*;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 费用登记 DO
 *
 * @author 系统管理员
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_box_cost")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class BoxCostDO extends BaseDO {

    /**
     *
     */
    @TableId
    private Long id;
    /**
     *
     */
    private Long shipmentId;
    /**
     * 操作步骤类型
     */
    private String opStepType;
    /**
     * 费用类型
     */
    private String costType;
    /**
     * 供应商ID
     */
    private Long supplierId;
    /**
     * 金额
     */
    private java.math.BigDecimal price;
    /**
     * 金额单位ID
     */
    private Long priceUnit;
    /**
     * 备注
     */
    private String remarks;

    /*
    费用产生时间 lanbm 2024-05-17 add
    */
    private Date freecsdate;

}
