package cn.iocoder.yudao.module.shipment.service.makeBillOfLading;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.core.util.ZipUtil;
import cn.iocoder.yudao.framework.common.exception.ServiceException;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.date.DateUtils;
import cn.iocoder.yudao.framework.dict.core.dto.DictDataRespDTO;
import cn.iocoder.yudao.framework.dict.core.util.DictFrameworkUtils;
import cn.iocoder.yudao.framework.file.core.client.FileClient;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.service.AbstractService;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.security.core.util.SecurityFrameworkUtils;
import cn.iocoder.yudao.module.bpm.api.BpmCreateServiceFactory;
import cn.iocoder.yudao.module.bpm.enums.WorkFlowEmus;
import cn.iocoder.yudao.module.customer.dal.dataobject.customer.CustomerDO;
import cn.iocoder.yudao.module.customer.service.customer.CustomerService;
import cn.iocoder.yudao.module.depository.dal.dataobject.warehouse.WarehouseDO;
import cn.iocoder.yudao.module.depository.dal.mysql.warehouse.WarehouseLineMapper;
import cn.iocoder.yudao.module.depository.dto.LogisticsInfoDto;
import cn.iocoder.yudao.module.depository.service.warehouse.WarehouseService;
import cn.iocoder.yudao.module.ecw.api.currency.CurrencyApi;
import cn.iocoder.yudao.module.ecw.api.currency.dto.ExchangeRateRespDTO;
import cn.iocoder.yudao.module.ecw.dal.dataobject.cabinet.CabinetDO;
import cn.iocoder.yudao.module.ecw.dal.dataobject.currency.CurrencyDO;
import cn.iocoder.yudao.module.ecw.dal.dataobject.ladingTemplate.LadingTemplateDO;
import cn.iocoder.yudao.module.ecw.service.cabinet.CabinetService;
import cn.iocoder.yudao.module.ecw.service.currency.CurrencyService;
import cn.iocoder.yudao.module.ecw.service.ladingTemplate.LadingTemplateService;
import cn.iocoder.yudao.module.infra.service.file.FileConfigService;
import cn.iocoder.yudao.module.order.dal.dataobject.order.OrderDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderItem.OrderItemDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderObjective.OrderObjectiveDO;
import cn.iocoder.yudao.module.order.dto.OrderBackInfoDto;
import cn.iocoder.yudao.module.order.service.approval.OrderApprovalService;
import cn.iocoder.yudao.module.order.service.order.*;
import cn.iocoder.yudao.module.order.util.AirHtmlToPdfUtil;
import cn.iocoder.yudao.module.order.vo.order.OrderBackVO;
import cn.iocoder.yudao.module.order.vo.orderConsignee.OrderConsigneeBackVO;
import cn.iocoder.yudao.module.order.vo.orderConsignor.OrderConsignorBackVO;
import cn.iocoder.yudao.module.shipment.convert.makeBillOfLading.MakeBillOfLadingConvert;
import cn.iocoder.yudao.module.shipment.dal.dataobject.BoxBookAirDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.BoxBookSeaDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.BoxDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.BoxPreloadGoodsDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.makeBillOfLading.MakeBillOfLadingDO;
import cn.iocoder.yudao.module.shipment.dal.mysql.makeBillOfLading.MakeBillOfLadingMapper;
import cn.iocoder.yudao.module.shipment.service.box.BoxService;
import cn.iocoder.yudao.module.shipment.service.boxBookAir.BoxBookAirService;
import cn.iocoder.yudao.module.shipment.service.boxBookSea.BoxBookSeaService;
import cn.iocoder.yudao.module.shipment.service.boxPreloadGoods.BoxPreloadGoodsService;
import cn.iocoder.yudao.module.shipment.utils.FreeMarkerUtil;
import cn.iocoder.yudao.module.shipment.vo.boxPreloadGoods.BoxPreloadGoodsBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxPreloadGoods.BoxPreloadGoodsQueryVO;
import cn.iocoder.yudao.module.shipment.vo.makeBillOfLading.MakeBillOfLadingCreateReqVO;
import cn.iocoder.yudao.module.shipment.vo.makeBillOfLading.MakeBillOfLadingListBackVO;
import cn.iocoder.yudao.module.shipment.vo.makeBillOfLading.MakeBillOfLadingQueryVO;
import cn.iocoder.yudao.module.shipment.vo.makeBillOfLading.MakeBillOfLadingUpdateReqVO;
import cn.iocoder.yudao.module.wealth.dal.dataobject.receivable.ReceivableDO;
import cn.iocoder.yudao.module.wealth.service.receivable.ReceivableService;
import cn.iocoder.yudao.module.wealth.vo.receivable.ReceivableBackVO;
import cn.iocoder.yudao.module.wealth.vo.receivable.ReceivableOrderPayedFeeTypeVO;
import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.itextpdf.text.Document;
import com.itextpdf.text.PageSize;
import com.itextpdf.text.pdf.PdfWriter;
import com.itextpdf.tool.xml.XMLWorkerHelper;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.jetbrains.annotations.NotNull;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.io.*;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.net.URL;
import java.nio.charset.Charset;
import java.util.*;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.order.enums.ErrorCodeConstants.ORDER_EXCEPTION_OR_PROCESSING_ERROR;
import static cn.iocoder.yudao.module.shipment.enums.ErrorCodeConstants.*;

/**
 * 制作提货单 Service 实现类
 *
 * @author 系统管理员
 */
@Service
@Validated
@Slf4j
public class MakeBillOfLadingServiceImpl extends AbstractService<MakeBillOfLadingMapper, MakeBillOfLadingDO> implements MakeBillOfLadingService {

    @Resource
    private MakeBillOfLadingMapper makeBillOfLadingMapper;

    @Resource
    private OrderService orderService;
    @Resource
    private OrderBusinessService orderBusinessService;
    @Resource
    private OrderQueryService orderQueryService;

    @Value("${ue.root-path}")
    private String prePath;

    @Value("${ue.templates-url}")
    private String path;

    @Resource
    private CustomerService customerService;

    @Resource
    private LadingTemplateService ladingTemplateService;

    @Resource
    private OrderItemService orderItemService;

    @Resource
    private BpmCreateServiceFactory bpmCreateServiceFactory;

    @Resource
    private BoxPreloadGoodsService boxPreloadGoodsService;

    @Resource
    private BoxService boxService;

    @Resource
    private CabinetService cabinetService;

    @Resource
    private ReceivableService receivableService;

    @Resource
    private BoxBookSeaService boxBookSeaService;

    @Resource
    private CurrencyService currencyService;

    @Resource
    private WarehouseLineMapper warehouseLineMapper;

    @Resource
    private OrderApprovalService orderApprovalService;

    @Resource
    private BoxBookAirService boxBookAirService;

    @Resource
    private FileConfigService fileConfigService;

    @Resource
    private OrderAirService orderAirService;

    @Resource
    private OrderObjectiveService orderObjectiveService;

    @Resource
    private WarehouseService warehouseService;

    @Resource
    private CurrencyApi currencyApi;

    @SneakyThrows
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Long createMakeBillOfLading(MakeBillOfLadingCreateReqVO createReqVO) {
        Long aLong = makeBillOfLadingMapper.selectCount(MakeBillOfLadingDO::getOrderId, createReqVO.getOrderId());
        if (aLong != null && aLong > 0L) {
            throw exception(MAKE_BILL_OF_LADING_EXISTS);
        }

        OrderBackInfoDto info = orderQueryService.info(Long.valueOf(createReqVO.getOrderId()));
        if (info.getAbnormalState() != 0 || info.getAuditType() != 0) {
            throw exception(ORDER_EXCEPTION_OR_PROCESSING_ERROR);
        }

        // 插入
        MakeBillOfLadingDO makeBillOfLading = MakeBillOfLadingConvert.INSTANCE.convert(createReqVO);

        //查询shipmentId
        List<BoxPreloadGoodsDO> preloadGoodsDOList = boxPreloadGoodsService.list(new LambdaQueryWrapper<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getOrderId, createReqVO.getOrderId())
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );
        if (CollectionUtil.isEmpty(preloadGoodsDOList)) {
            throw new ServiceException(500, "订单未装柜");
        }
        Long shipmentId = preloadGoodsDOList.get(0).getShipmentId();
        makeBillOfLading.setShipmentId(shipmentId);

        LadingTemplateDO ladingTemplateByLineId = ladingTemplateService.getLadingTemplateByLineId(info.getLineId());
        if (ladingTemplateByLineId == null) {
            throw exception(LADING_TEMPLATE_NOT_SET);
        }

        if (null != createReqVO.getNeedBackend() && createReqVO.getNeedBackend()) {
            OrderDO orderDo = orderService.getById(createReqVO.getOrderId());

            OrderObjectiveDO orderObjectiveDO = orderObjectiveService.getByOrderId(orderDo.getOrderId());


            /*BoxDO box = boxService.getBox(shipmentId);

            String destStr = "";
            if (null != box && null != box.getDestWarehouseId()) {
                WarehouseDO warehouseDO = warehouseService.getWarehouse(box.getDestWarehouseId());
                destStr = warehouseDO.getTitleEn();
            }*/
            //得到订单目的仓
            String destStr = "";
            if (null != orderObjectiveDO && null != orderObjectiveDO.getObjectiveWarehouseId()) {
                WarehouseDO warehouseDO = warehouseService.getWarehouse(orderObjectiveDO.getObjectiveWarehouseId());
                destStr = warehouseDO.getTitleEn();
            }

            if (StrUtil.isBlank(orderDo.getContainerNumber())) {
                throw exception(MAKE_BILL_OF_SELF_NULL);
            }
            if (StrUtil.isBlank(orderDo.getTidanNo())) {
                throw exception(MAKE_BILL_OF_ORDER_NULL);
            }


            FileClient masterFileClient = fileConfigService.getMasterFileClient();
            String domain = masterFileClient.getDomain();
            //创建空运的PDF提单
            String pdfFileName = "/admin/shipment/" + StrUtil.blankToDefault(orderDo.getContainerNumber(), "") + "/pdf/" + StrUtil.blankToDefault(orderDo.getTidanNo(), "") + " " + StrUtil.blankToDefault(orderDo.getMarks(), "") + " " + StrUtil.blankToDefault(destStr, "") + ".pdf";
            String pdfUrl = domain + pdfFileName;
            String pdfPath = prePath + pdfFileName;
            try {
                AirHtmlToPdfUtil.convertHtmlToPdf(createReqVO.getBillContent(), pdfPath);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
            //设置生成的PDF路径
            makeBillOfLading.setImgUrl(pdfUrl);
        }

        makeBillOfLadingMapper.insert(makeBillOfLading);
        // 返回
        OrderDO orderDO = orderService.selectOne(OrderDO::getOrderId, createReqVO.getOrderId());
        String bpmProcessId = bpmCreateServiceFactory.createBmp(SecurityFrameworkUtils.getLoginUserId(), makeBillOfLading.getId(), WorkFlowEmus.SHIPMENT_BILL_LADING.getKey(), orderDO.getOrderNo(), createReqVO.getCopyUserId());
        makeBillOfLading.setBpmProcessId(bpmProcessId);
        makeBillOfLadingMapper.updateById(makeBillOfLading);
        orderBusinessService.addOrderOperateLog(Long.valueOf(createReqVO.getOrderId()), "出货操作", "提交提单制作审核", "");
        return makeBillOfLading.getId();
    }

    @Override
    public void updateMakeBillOfLading(MakeBillOfLadingUpdateReqVO updateReqVO) {
        // 校验存在
        this.validateMakeBillOfLadingExists(updateReqVO.getId());
        // 更新
        MakeBillOfLadingDO updateObj = MakeBillOfLadingConvert.INSTANCE.convert(updateReqVO);
        makeBillOfLadingMapper.updateById(updateObj);
        OrderBackVO order = orderQueryService.getOrder(Long.valueOf(makeBillOfLadingMapper.selectById(updateReqVO.getId()).getOrderId()));
        String bpmProcessId = bpmCreateServiceFactory.createBmp(SecurityFrameworkUtils.getLoginUserId(), updateReqVO.getId(), WorkFlowEmus.SHIPMENT_BILL_LADING.getKey(), order.getOrderNo(), updateReqVO.getCopyUserId());
        updateObj.setBpmProcessId(bpmProcessId);
        makeBillOfLadingMapper.updateById(updateObj);
    }

    @Override
    public void deleteMakeBillOfLading(Long id) {
        // 校验存在
        this.validateMakeBillOfLadingExists(id);
        // 删除
        makeBillOfLadingMapper.deleteById(id);
    }

    @Override
    public void updateAirBill(Collection<Long> orderIds) {
        FileClient masterFileClient = fileConfigService.getMasterFileClient();
        String domain = null;
        try {
            domain = masterFileClient.getDomain();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }

        for (Long orderId : orderIds) {
            OrderDO orderDO = orderService.getById(orderId);
            if (null == orderDO) {
                log.error("订单ID:{},刷新提单时,订单不存在", orderId);
                continue;
            }
            if (orderDO.getTransportId() == 1 || orderDO.getTransportId() == 2) {
                log.error("订单:{},刷新提单时,订单为海运订单跳过", orderDO.getOrderNo());
                continue;
            }

            OrderObjectiveDO orderObjectiveDO = orderObjectiveService.getByOrderId(orderDO.getOrderId());
            //得到订单目的仓
            String destStr = "";
            if (null != orderObjectiveDO && null != orderObjectiveDO.getObjectiveWarehouseId()) {
                WarehouseDO warehouseDO = warehouseService.getWarehouse(orderObjectiveDO.getObjectiveWarehouseId());
                destStr = warehouseDO.getTitleEn();
            }

            if (StrUtil.isBlank(orderDO.getContainerNumber())) {
                log.error("订单:{},刷新提单时,自编号为空跳过", orderDO.getOrderNo());
                continue;
            }
            if (StrUtil.isBlank(orderDO.getTidanNo())) {
                log.error("订单:{},刷新提单时,自编号为空跳过", orderDO.getOrderNo());
                continue;
            }

            LambdaQueryWrapper<MakeBillOfLadingDO> makeBillOfLadingDOLambdaQueryWrapper = new LambdaQueryWrapper<>();
            makeBillOfLadingDOLambdaQueryWrapper.eq(MakeBillOfLadingDO::getOrderId, orderId);
            List<MakeBillOfLadingDO> makeBillOfLadingDOList = this.selectList(makeBillOfLadingDOLambdaQueryWrapper);

            if (null == makeBillOfLadingDOList || makeBillOfLadingDOList.size() == 0) {
                log.error("订单:{},刷新提单时,富文本为空", orderDO.getOrderNo());
                continue;
            }

            MakeBillOfLadingDO makeBillOfLadingDO = makeBillOfLadingDOList.get(0);
            if (null == makeBillOfLadingDO || StrUtil.isBlank(makeBillOfLadingDO.getBillContent())) {
                log.error("订单:{},刷新提单时,富文本为空", orderDO.getOrderNo());
                continue;
            }

            //创建空运的PDF提单
            String pdfFileName = "/admin/shipment/" + StrUtil.blankToDefault(orderDO.getContainerNumber(), "") + "/pdf/" + StrUtil.blankToDefault(orderDO.getTidanNo(), "") + " " + StrUtil.blankToDefault(orderDO.getMarks(), "") + " " + StrUtil.blankToDefault(destStr, "") + ".pdf";
            String pdfUrl = domain + pdfFileName;
            String pdfPath = prePath + pdfFileName;
            try {
                AirHtmlToPdfUtil.convertHtmlToPdf(makeBillOfLadingDO.getBillContent(), pdfPath);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }

            //设置生成的PDF路径
            makeBillOfLadingDO.setImgUrl(pdfUrl);
            makeBillOfLadingMapper.updateById(makeBillOfLadingDO);

            if (makeBillOfLadingDO != null) {
                orderBusinessService.addOrderOperateLog(Long.valueOf(makeBillOfLadingDO.getOrderId()), "出货操作", "刷新提单", "");
            }
        }


    }


    private void validateMakeBillOfLadingExists(Long id) {
        if (makeBillOfLadingMapper.selectById(id) == null) {
            throw exception(MAKE_BILL_OF_LADING_NOT_EXISTS);
        }
    }

    @Override
    public MakeBillOfLadingDO getMakeBillOfLading(Long id) {
        return makeBillOfLadingMapper.selectById(id);
    }

    @Override
    public List<MakeBillOfLadingDO> getMakeBillOfLadingList(Collection<Long> ids) {
        return makeBillOfLadingMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<MakeBillOfLadingDO> getMakeBillOfLadingPage(MakeBillOfLadingQueryVO query, PageVO page) {
        return makeBillOfLadingMapper.selectPage(page, query);
    }

    @Override
    public List<MakeBillOfLadingDO> getMakeBillOfLadingList(MakeBillOfLadingQueryVO query) {
        return makeBillOfLadingMapper.selectList(query);
    }

    @Override
    public Map<String, Object> makeBillOfLading(Long orderId, Long shipmentId) throws Exception {
        List<CurrencyDO> currencyList = currencyService.getCurrencyList();
        Map<Integer, String> currencyMap = currencyList.stream().collect(Collectors.toMap(CurrencyDO::getId, CurrencyDO::getTitleEn, (key1, key2) -> key2));
        Map<String, BigDecimal> totalFeeMap = new HashMap();
        Map<String, Object> map = new HashMap<>(4);
        Map<String, Object> templateMap = new HashMap<>();
        Map<String, Object> orderInfoMap = new HashMap<>();
        OrderBackInfoDto info = orderQueryService.info(orderId);
        if (info.getAbnormalState() != 0 || info.getAuditType() != 0) {
            throw exception(ORDER_EXCEPTION_OR_PROCESSING_ERROR);
        }
        CustomerDO customer = customerService.getCustomer(info.getCustomerId());
        //订单基本信息
        orderInfoMap.put("consignee", info.getConsigneeVO().getName());
        orderInfoMap.put("consigneePhone", "+" + info.getConsigneeVO().getCountryCode() + info.getConsigneeVO().getPhone());
        orderInfoMap.put("consignor", info.getConsignorVO().getName());
        orderInfoMap.put("consignorPhone", "+" + info.getConsignorVO().getCountryCode() + info.getConsignorVO().getPhone());
        if (info.getDrawee() == 1) { //订单付款人为发货人
            String shipperName = getShipperNameAndConsignee(info, 1, orderInfoMap);
            orderInfoMap.put("consignor", shipperName);
        } else if (info.getDrawee() == 2) { //订单付款人为收货人
            String consigneeName = getShipperNameAndConsignee(info, 2, orderInfoMap);
            orderInfoMap.put("consignee", consigneeName);
        }
        orderInfoMap.put("orderNo", info.getOrderNo());
        orderInfoMap.put("plNo", info.getTidanNo());
        LogisticsInfoDto startInfoAndDestInfoByLineId = warehouseLineMapper.getStartInfoAndDestInfoByLineId(info.getLineId());
//        JSONObject jsonObject = JSONObject.parseObject(info.getObjectiveVO().getObjective());
        orderInfoMap.put("objectiveName", startInfoAndDestInfoByLineId.getDestTitleEn());
        if (info.getTransportId() == 3) {
            BoxBookAirDO boxBookAirDO = boxBookAirService.getOne(new LambdaQueryWrapperX<BoxBookAirDO>().eq(BoxBookAirDO::getShipmentId, shipmentId).orderByDesc(BaseDO::getCreateTime).last(" limit 1"));
            orderInfoMap.put("zgDate", DateUtils.formatDate(boxBookAirDO.getFlyTime()));
        } else {
            BoxBookSeaDO boxBookSeaDO = boxBookSeaService.getOne(new LambdaQueryWrapperX<BoxBookSeaDO>()
                    .eq(BoxBookSeaDO::getShipmentId, shipmentId).orderByDesc(BaseDO::getCreateTime).last(" limit 1"));
            orderInfoMap.put("zgDate", DateUtils.formatDate(boxBookSeaDO.getSailTime()));
        }
        templateMap.put("orderInfo", orderInfoMap);//订单基本信息
        BoxPreloadGoodsQueryVO boxPreloadGoodsQueryVO = new BoxPreloadGoodsQueryVO();
        boxPreloadGoodsQueryVO.setShipmentId(shipmentId);
        boxPreloadGoodsQueryVO.setOrderId(orderId);
        List<BoxPreloadGoodsDO> boxPreloadGoodsList = boxPreloadGoodsService.getBoxPreloadGoodsList(boxPreloadGoodsQueryVO);
        List<Long> orderItemIds = boxPreloadGoodsList.stream().map(BoxPreloadGoodsDO::getOrderItemId).collect(Collectors.toList());
        List<OrderItemDO> orderItemVOList = orderItemService.getOrderItemList(orderItemIds);
        AtomicInteger atomicInteger = new AtomicInteger(1);
        Map<String, Object> totalItemMap = new HashMap<>();
        List<Map<String, Object>> dataList = orderItemVOList.stream().filter(item -> item.getWarehouseInInfoVO() != null).map(item -> {
            Map<String, Object> paramMap = new HashMap<>();
            //订单项
            paramMap.put("index", atomicInteger.getAndIncrement());
            paramMap.put("mark", info.getMarks());
            paramMap.put("desc", item.getProdTitleEn());
            paramMap.put("num", item.getWarehouseInInfoVO().getCartonsNum());
            paramMap.put("volume", item.getWarehouseInInfoVO().getVolume());
            paramMap.put("weight", Objects.nonNull(item.getChargeVolume()) && item.getChargeVolume().compareTo(item.getMinMeteringVolume()) > 0 ? item.getChargeVolume() : item.getMinMeteringVolume());
//            if (Objects.isNull(info.getOrderType()) || info.getOrderType() == 0 || info.getOrderType() != 3) {
//            } else {
//                paramMap.put("weight", item.getWVolume());
//            }
            paramMap.put("seaFreight", item.getOneSeaFreight() + currencyMap.get(item.getSeaFreightCurrency()) + "/m³");
            if (item.getOneClearanceFreight().compareTo(BigDecimal.ZERO) == 0) {
                if (item.getClearanceFreightCurrency() == null ||
                        item.getClearanceFreightCurrency() == 0 ||
                        currencyMap.get(item.getClearanceFreightCurrency()) == null) {
                    //lanbm 2024-05-07 调整逻辑判断，是币种字段为空则显示0
                    //item.getClearanceFreightCurrency() 币种项在数据字典中不存在
                    paramMap.put("clearanceFreight", "0");
                } else {
                    paramMap.put("clearanceFreight",
                            "0" + currencyMap.get(item.getClearanceFreightCurrency()) + "/m³");
                    //paramMap.put("clearanceFreight", "");
                    //lanbm 2024-04-25 update 提单制作，清关价为0问题修改
                }
            } else {
                paramMap.put("clearanceFreight",
                        item.getOneClearanceFreight() + currencyMap.get(item.getClearanceFreightCurrency()) + "/m³");
            }
            return paramMap;
        }).collect(Collectors.toList());
        //订单项合计
        int totalNum = orderItemVOList.stream().filter(item -> item.getWarehouseInInfoVO() != null).mapToInt(item -> item.getWarehouseInInfoVO().getCartonsNum()).sum();
        BigDecimal totalVolume = BigDecimal.ZERO;
        BigDecimal totalWeight = BigDecimal.ZERO;
        for (OrderItemDO orderItemDO : orderItemVOList) {
            if (orderItemDO.getWarehouseInInfoVO() != null) {
                totalVolume = totalVolume.add(orderItemDO.getWarehouseInInfoVO().getVolume());
                if (Objects.nonNull(orderItemDO.getChargeVolume()) && orderItemDO.getChargeVolume().compareTo(orderItemDO.getMinMeteringVolume()) > 0) {
                    totalWeight = totalWeight.add(orderItemDO.getChargeVolume());
                } else {
                    totalWeight = totalWeight.add(orderItemDO.getMinMeteringVolume());
                }
            }
        }
//        BigDecimal totalWeight = orderItemVOList.stream().map(OrderItemDO::getChargeVolume).reduce(BigDecimal.ZERO, BigDecimal::add);
//        if (Objects.isNull(info.getOrderType()) || info.getOrderType() == 0 || info.getOrderType() != 3) {
//            totalWeight = totalVolume;
//        } else {
//            totalWeight = orderItemVOList.stream().map(OrderItemDO::getWVolume).reduce(BigDecimal.ZERO, BigDecimal::add);
//        }
        StringBuffer seaStringBuffer = getStringBuffer(totalFeeMap, orderItemIds, 1);//运费
        StringBuffer clearanceStringBuffer = getStringBuffer(totalFeeMap, orderItemIds, 2);//清关费
        //模板变量
        totalItemMap.put("totalNum", totalNum);
        totalItemMap.put("totalVolume", totalVolume);
        totalItemMap.put("totalWeight", totalWeight);
        totalItemMap.put("totalSeaFreight", seaStringBuffer.length() == 0 ? "" : seaStringBuffer.deleteCharAt(seaStringBuffer.length() - 1));
        totalItemMap.put("totalClearanceFreight", clearanceStringBuffer.length() == 0 ? "" : clearanceStringBuffer.deleteCharAt(clearanceStringBuffer.length() - 1));
        templateMap.put("totalItemMap", totalItemMap);//订单项总计
        templateMap.put("dataList", dataList);//订单项

        //其他费用
        List<ReceivableBackVO> receivableListByOrder = receivableService.getReceivableListByOrderId(orderId);
        List<Map<String, Object>> otherFeeList = receivableListByOrder.stream().filter(item -> item.getFeeSource() != 1).map(item -> {
            Map<String, Object> otherFeeMap = new HashMap<>();
            DictDataRespDTO receivable_fee_type = DictFrameworkUtils.getDictDataFromCache("receivable_fee_type", String.valueOf(item.getFeeType()));
            otherFeeMap.put("name", receivable_fee_type.getLabel() + "(" + receivable_fee_type.getLabelEn() + ")");
            otherFeeMap.put("currency", currencyMap.get(item.getCurrencyId().intValue()));
            otherFeeMap.put("amount", item.getTotalAmount());
            if (item.getCurrencyId() != null) {
                if (totalFeeMap.get(String.valueOf(item.getCurrencyId())) == null) {
                    totalFeeMap.put(String.valueOf(item.getCurrencyId()), item.getTotalAmount());
                } else {
                    totalFeeMap.put(String.valueOf(item.getCurrencyId()), totalFeeMap.get(String.valueOf(item.getCurrencyId())).add(item.getTotalAmount()));
                }
            }
            return otherFeeMap;
        }).collect(Collectors.toList());

        templateMap.put("otherFeeList", otherFeeList);//其他费用
        Map<String, Object> worthMap = new HashMap<>();
        worthMap.put("totalWorth", info.getCostVO().getTotalWorth() + "RMB");
        worthMap.put("insuranceFee", info.getCostVO().getInsuranceFee());
        worthMap.put("insuranceFeeCurrency", currencyMap.get(info.getCostVO().getInsuranceCurrencyId().intValue()));
        templateMap.put("worthMap", worthMap);//货值和保价费
        BigDecimal bigDecimal = totalFeeMap.get(String.valueOf(info.getCostVO().getInsuranceCurrencyId()));//保价费默认美元
        if (bigDecimal == null) {
            totalFeeMap.put(String.valueOf(info.getCostVO().getInsuranceCurrencyId()), info.getCostVO().getInsuranceFee());
        } else {
            totalFeeMap.put(String.valueOf(info.getCostVO().getInsuranceCurrencyId()), bigDecimal.add(info.getCostVO().getInsuranceFee()));
        }
        StringBuffer stringBuffer = new StringBuffer();
        List<ReceivableOrderPayedFeeTypeVO> payedFeeTypeVOList = receivableService.getPayedMoneyByFeeType(orderId);
        Map<Long, BigDecimal> payedAmount = new HashMap<>();
        if (payedFeeTypeVOList != null) {
            payedAmount = payedFeeTypeVOList.stream().collect(Collectors.groupingBy(ReceivableOrderPayedFeeTypeVO::getCurrencyId, Collectors.reducing(BigDecimal.ZERO, ReceivableOrderPayedFeeTypeVO::getPayedAmount, BigDecimal::add)));
        }
        if (totalFeeMap.size() > 0) {
            for (Map.Entry<String, BigDecimal> item : totalFeeMap.entrySet()) {
                BigDecimal money = item.getValue();
                if (payedAmount.get(Long.valueOf(item.getKey())) != null) {
                    money = item.getValue().subtract(payedAmount.get(Long.valueOf(item.getKey())));
                }
                money = money.setScale(0, RoundingMode.HALF_UP);
                stringBuffer.append(money + currencyMap.get(Integer.valueOf(item.getKey()))).append(" ");
            }
        }
        templateMap.put("totalFee", stringBuffer.toString());//总费用
        LadingTemplateDO ladingTemplateByLineId = ladingTemplateService.getLadingTemplateByLineId(info.getLineId());
        if (StringUtils.isNotBlank(ladingTemplateByLineId.getAccount())) {
            templateMap.put("acctList", JSONArray.parseArray(ladingTemplateByLineId.getAccount()));
        } else {
            templateMap.put("acctList", new ArrayList<>());
        }
        //调用工具类抓取html代码
        String template = "";
        if (!info.getDisplayBillLadingPrice()) {
            template = FreeMarkerUtil.parseTemplate("/templates/", "templateNoFee.ftl", templateMap);
        } else {
            template = FreeMarkerUtil.parseTemplate("/templates/", "template.ftl", templateMap);
        }
        map.put("orderInfo", template);
        map.put("ladingTemplate", ladingTemplateByLineId);
        return map;
    }

    @NotNull
    private StringBuffer getStringBuffer(Map<String, BigDecimal> totalFeeMap, List<Long> orderItemIds, int val) {
        List<ReceivableDO> sealist = receivableService.list(new LambdaQueryWrapperX<ReceivableDO>().eq(ReceivableDO::getFeeType, val).in(ReceivableDO::getOrderItemId, orderItemIds));
        Map<Long, List<ReceivableDO>> collect = sealist.stream()
                .collect(Collectors.groupingBy(ReceivableDO::getCurrencyId));
        StringBuffer stringBuffer = new StringBuffer();
        for (Map.Entry<Long, List<ReceivableDO>> entry : collect.entrySet()) {
            if (entry.getKey() != 0L) {
                BigDecimal sea = entry.getValue().stream().map(ReceivableDO::getTotalAmount).reduce(BigDecimal.ZERO, BigDecimal::add);
                sea = sea.setScale(0, BigDecimal.ROUND_HALF_UP);
                stringBuffer.append(sea + currencyService.getCurrency(entry.getKey().intValue()).getTitleEn()).append(" ");
                if (entry.getKey() != null) {
                    if (totalFeeMap.get(String.valueOf(entry.getKey())) == null) {
                        totalFeeMap.put(String.valueOf(entry.getKey()), sea);
                    } else {
                        totalFeeMap.put(String.valueOf(entry.getKey()), totalFeeMap.get(String.valueOf(entry.getKey())).add(sea));
                    }
                }
            }
        }
        return stringBuffer;
    }

    private String getShipperNameAndConsignee(OrderBackInfoDto info, int type, Map<String, Object> map) { //type为1查shipper 为其他查consignee
        StringBuffer stringBuffer = new StringBuffer("");
        Pattern pattern = Pattern.compile("[\u4e00-\u9fa5]");
//        String companyEn = null;
        if (type == 1 && StringUtils.isNotBlank(info.getConsignorVO().getCompanyEn())) {
            map.put("consignorCompany", info.getConsignorVO().getCompanyEn());
        } else if (type == 2 && StringUtils.isNotBlank(info.getConsigneeVO().getCompanyEn())) {
            map.put("consigneeCompany", info.getConsigneeVO().getCompanyEn());
        }
//        stringBuffer.append(companyEn).append("\r\n");
        CustomerDO customerConsignor = null;
        if (type == 1) {
            //当发货人为订单付款人  订单页面发货人公司英文名称客户档案付款人名字+发货人英文名字
            customerConsignor = customerService.getCustomer(info.getConsignorVO().getCustomerId());
        } else {
            //当收货人为订单付款人  订单页面发货人公司英文名称客户档案付款人名字+发货人英文名字
            customerConsignor = customerService.getCustomer(info.getConsigneeVO().getCustomerId());
        }
        if (customerConsignor != null && StringUtils.isNotBlank(customerConsignor.getPayerName())) {
            String name = customerConsignor.getPayerName();
            String nameEn = "";
            if (type == 1) {
                nameEn = info.getConsignorVO().getNameEn();
            } else {
                nameEn = info.getConsigneeVO().getNameEn();
            }
            if (customerConsignor.getPayerName().equals(customerConsignor.getNameEn()) && !pattern.matcher(customerConsignor.getPayerName()).find()) {
                stringBuffer.append(StringUtils.isBlank(name) ? "" : name);
            } else {
                stringBuffer.append(StringUtils.isBlank(name) ? "" : name).append(" ").append(StringUtils.isBlank(nameEn) ? "" : nameEn);
            }
        } else {
            //订单页面发货人公司英文名称+发货人名字+发货人英文名字
            if (type == 1) {
                OrderConsignorBackVO consignorVO = info.getConsignorVO();
                String name = consignorVO.getName();
                String nameEn = consignorVO.getNameEn();
                if (consignorVO.getName().equals(consignorVO.getNameEn()) && !pattern.matcher(consignorVO.getName()).find()) {
                    stringBuffer.append(StringUtils.isBlank(name) ? "" : name);
                } else {
                    stringBuffer.append(StringUtils.isBlank(name) ? "" : name).append(" ").append(StringUtils.isBlank(nameEn) ? "" : nameEn);
                }
            } else {
                OrderConsigneeBackVO consignorVO = info.getConsigneeVO();
                String name = consignorVO.getName();
                String nameEn = consignorVO.getNameEn();
                if (consignorVO.getName().equals(consignorVO.getNameEn()) && !pattern.matcher(consignorVO.getName()).find()) {
                    stringBuffer.append(StringUtils.isBlank(name) ? "" : name);
                } else {
                    stringBuffer.append(StringUtils.isBlank(name) ? "" : name).append(" ").append(StringUtils.isBlank(nameEn) ? "" : nameEn);
                }
            }
        }
        return stringBuffer.toString();
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void updateBillOfLadingResult(String id, int result) {
        MakeBillOfLadingDO makeBillOfLadingDO = new MakeBillOfLadingDO();
        makeBillOfLadingDO.setId(Long.valueOf(id));
        makeBillOfLadingDO.setStatus(result);
        MakeBillOfLadingDO makeBillOfLadingDO1 = makeBillOfLadingMapper.selectById(id);
        if (result == 4) {
            makeBillOfLadingMapper.updateById(makeBillOfLadingDO);
            makeBillOfLadingMapper.deleteById(Long.valueOf(id));
            if (makeBillOfLadingDO1 != null) {
                orderBusinessService.addOrderOperateLog(Long.valueOf(makeBillOfLadingDO1.getOrderId()), "出货操作", "取消提单制作审核", "");
            }
        } else if (result == 3) {
            makeBillOfLadingMapper.updateById(makeBillOfLadingDO);
            if (makeBillOfLadingDO1 != null) {
                orderBusinessService.addOrderOperateLog(Long.valueOf(makeBillOfLadingDO1.getOrderId()), "出货操作", "提单制作审核失败", "");
            }
        } else if (result == 2) {
            //重新生成新的空运提单
            OrderDO orderDo = orderService.getById(makeBillOfLadingDO1.getOrderId());
            if (orderDo.getTransportId() != 1 && orderDo.getTransportId() != 2) {

                FileClient masterFileClient = fileConfigService.getMasterFileClient();
                String domain = null;
                try {
                    domain = masterFileClient.getDomain();
                } catch (Exception e) {
                    throw new RuntimeException(e);
                }

                OrderObjectiveDO orderObjectiveDO = orderObjectiveService.getByOrderId(orderDo.getOrderId());

                //得到订单目的仓
                String destStr = "";
                if (null != orderObjectiveDO && null != orderObjectiveDO.getObjectiveWarehouseId()) {
                    WarehouseDO warehouseDO = warehouseService.getWarehouse(orderObjectiveDO.getObjectiveWarehouseId());
                    destStr = warehouseDO.getTitleEn();
                }

                if (StrUtil.isBlank(orderDo.getContainerNumber())) {
                    throw exception(MAKE_BILL_OF_SELF_NULL);
                }
                if (StrUtil.isBlank(orderDo.getTidanNo())) {
                    throw exception(MAKE_BILL_OF_ORDER_NULL);
                }


                //创建空运的PDF提单
                String pdfFileName = "/admin/shipment/" + StrUtil.blankToDefault(orderDo.getContainerNumber(), "") + "/pdf/" + StrUtil.blankToDefault(orderDo.getTidanNo(), "") + " " + StrUtil.blankToDefault(orderDo.getMarks(), "") + " " + StrUtil.blankToDefault(destStr, "") + ".pdf";
                String pdfUrl = domain + pdfFileName;
                String pdfPath = prePath + pdfFileName;
                try {
                    AirHtmlToPdfUtil.convertHtmlToPdf(makeBillOfLadingDO1.getBillContent(), pdfPath);
                } catch (Exception e) {
                    throw new RuntimeException(e);
                }
                //设置生成的PDF路径
                makeBillOfLadingDO.setImgUrl(pdfUrl);
            }
            makeBillOfLadingMapper.updateById(makeBillOfLadingDO);
            if (makeBillOfLadingDO1 != null) {

                orderBusinessService.addOrderOperateLog(Long.valueOf(makeBillOfLadingDO1.getOrderId()), "出货操作", "提单制作审核通过", "");
            }
        }
//        if (result == 2) {
//            MakeBillOfLadingDO makeBillOfLadingDO1 = makeBillOfLadingMapper.selectById(id);
//            Long orderId = Long.valueOf(makeBillOfLadingDO1.getOrderId());
//            String orderLadingBillNo = boxPreloadGoodsService.getLadingBillNo(orderId);
//            orderService.updateLadingBillNo(orderId, orderLadingBillNo);
//        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void cancel(Long id) {
        MakeBillOfLadingDO makeBillOfLadingDO = makeBillOfLadingMapper.selectById(id);
//        makeBillOfLadingMapper.deleteById(id);
        bpmCreateServiceFactory.cancelBmpById(SecurityFrameworkUtils.getLoginUserId(), makeBillOfLadingDO.getBpmProcessId(), "取消");
//        orderBusinessService.addOrderOperateLog(Long.valueOf(makeBillOfLadingDO.getOrderId()),"出货操作","取消提单制作审核","");
    }

    @Override
    public Map<String, Object> getMakeLadingBillList(Long shipmentId) {
        CabinetDO cabinet = cabinetService.getCabinet(boxService.getById(shipmentId).getCabinetId());
        Map<String, Object> map = new HashMap<>(4);
        List<MakeBillOfLadingListBackVO> list = new ArrayList<>();
        List<BoxPreloadGoodsBackVO> goodsItemList = boxPreloadGoodsService.getShipGoodItemList(shipmentId);
        //以secId排序
        goodsItemList.sort(Comparator.comparingLong(BoxPreloadGoodsBackVO::getTidanNum));

        //以订单ID分组
        Map<Long, List<BoxPreloadGoodsBackVO>> orderMap = goodsItemList.stream()
                .collect(Collectors.groupingBy(BoxPreloadGoodsBackVO::getOrderId, LinkedHashMap::new, Collectors.toList()));

        int totalNum = 0;
        BigDecimal totalVolume = BigDecimal.ZERO;
        BigDecimal totalWeight = BigDecimal.ZERO;

        for (Map.Entry<Long, List<BoxPreloadGoodsBackVO>> entry : orderMap.entrySet()) {
            Long orderId = entry.getKey();
            List<BoxPreloadGoodsBackVO> orderGoodsItemList = entry.getValue();
            MakeBillOfLadingListBackVO makeBillOfLadingListBackVO = makeBillOfLadingMapper.getLadingBillOrderInfo(orderId);
//            makeBillOfLadingListBackVO.setOrderStatusString(DictFrameworkUtils.getDictDataFromCache("order_status",String.valueOf(order.getStatus())).getLabel());
//            makeBillOfLadingListBackVO.setRucangTime(order.getRucangTime());
            BoxPreloadGoodsBackVO firstBoxPreloadGoodsBackVO = orderGoodsItemList.get(0);
            makeBillOfLadingListBackVO.setOrderStatusString(firstBoxPreloadGoodsBackVO.getStatusMsg());
            // 首次入仓时间
            makeBillOfLadingListBackVO.setRucangTime(firstBoxPreloadGoodsBackVO.getRucangTime());
            makeBillOfLadingListBackVO.setOrderItemList(orderGoodsItemList);
            makeBillOfLadingListBackVO.setTidanNo(firstBoxPreloadGoodsBackVO.getTidanNum());
            String customsTypeName = "";
            if (makeBillOfLadingListBackVO.getCustomsType() == 2) {
                customsTypeName = "自单代报";
            } else if (makeBillOfLadingListBackVO.getCustomsType() == 3) {
                customsTypeName = "混合报关";
            }
            if (StringUtils.isNotBlank(customsTypeName)) {
                makeBillOfLadingListBackVO.setCustomsTypeName(customsTypeName);
            }
            if (makeBillOfLadingListBackVO.getDraweeCode() == 1) {
                makeBillOfLadingListBackVO.setDrawee("付款人=发货人");
            } else if (makeBillOfLadingListBackVO.getDraweeCode() == 3) {
                makeBillOfLadingListBackVO.setDrawee("付款人=自定义");
            }
//            List typeList = new ArrayList();
//            typeList.add(1);
//            typeList.add(4);
//            List<OrderApprovalDO> orderApprovalDOS = orderApprovalService.selectList(new LambdaQueryWrapperX<OrderApprovalDO>().eq(OrderApprovalDO::getOrderId, orderId).in(OrderApprovalDO::getType, typeList));
//            long count = orderApprovalDOS.stream().filter(item -> item.getType() == 1).count();
//            long count1 = orderApprovalDOS.stream().filter(item -> item.getType() == 4).count();
            StringBuffer stringBuffer = new StringBuffer("");
            if (makeBillOfLadingListBackVO.getSpecialPriceCount() > 0L) {
                stringBuffer.append("申请特价").append(",");
            }
            if (makeBillOfLadingListBackVO.getHeavyDiscount() > 0L) {
                stringBuffer.append("申请重货优惠").append(",");
            }
            if (stringBuffer.length() > 0) {
                makeBillOfLadingListBackVO.setApplicationInfo(stringBuffer.deleteCharAt(stringBuffer.length() - 1).toString());
            }
            list.add(makeBillOfLadingListBackVO);
            totalNum = totalNum + makeBillOfLadingListBackVO.getNum();
            totalVolume = totalVolume.add(makeBillOfLadingListBackVO.getLoadVolume());
            totalWeight = totalWeight.add(makeBillOfLadingListBackVO.getLoadWeight());
//
//            //计算总箱数
//            int numSum = orderGoodsItemList.stream()
//                    .filter(t -> t.getNum() != null)
//                    .mapToInt(BoxPreloadGoodsBackVO::getNum)
//                    .sum();
//
//            //计算总体积
//            BigDecimal volumeSum = orderGoodsItemList.stream()
//                    .filter(t -> t.getVolume() != null)
//                    .map(BoxPreloadGoodsBackVO::getVolume)
//                    .reduce(BigDecimal.ZERO, BigDecimal::add);
//
//            //计算总重量
//            BigDecimal weightSum = orderGoodsItemList.stream()
//                    .filter(t -> t.getWeight() != null)
//                    .map(BoxPreloadGoodsBackVO::getWeight)
//                    .reduce(BigDecimal.ZERO, BigDecimal::add);
        }
        map.put("totalNum", totalNum);
        map.put("totalVolume", totalVolume);
        map.put("totalWeight", totalWeight);
        map.put("list", list);
        map.put("cabinet", cabinet);
        return map;
    }

    @Override
    public void zipDownload(Long shipmentId, String dir, String fileName) throws Exception {
        BoxDO box = boxService.getBox(shipmentId);
        File checkFile = new File(dir + fileName);
        if (checkFile.exists()) {
            checkFile.delete();
        }
        List<BoxPreloadGoodsBackVO> goodsItemList = boxPreloadGoodsService.getShipGoodItemList(shipmentId);
        //以secId排序
        goodsItemList.sort(Comparator.comparing(BoxPreloadGoodsBackVO::getSecId));

        //以订单ID分组
        Map<Long, List<BoxPreloadGoodsBackVO>> orderMap = goodsItemList.stream()
                .collect(Collectors.groupingBy(BoxPreloadGoodsBackVO::getOrderId));
        List<String> pathList = new ArrayList<>();
        List<InputStream> inputStreams = new ArrayList<>();
        for (Map.Entry<Long, List<BoxPreloadGoodsBackVO>> entry : orderMap.entrySet()) {
            Long orderId = entry.getKey();
            MakeBillOfLadingDO makeBillOfLadingDO = makeBillOfLadingMapper.selectOne(new LambdaQueryWrapperX<MakeBillOfLadingDO>().eq(MakeBillOfLadingDO::getOrderId, orderId).eq(MakeBillOfLadingDO::getStatus, 2).select(MakeBillOfLadingDO::getImgUrl));
            if (makeBillOfLadingDO == null) continue;
            if (StringUtils.isNotBlank(makeBillOfLadingDO.getImgUrl())) {
                if (StringUtils.isNotBlank(makeBillOfLadingDO.getImgUrl())) {
                    String[] file = makeBillOfLadingDO.getImgUrl().split("/");
                    String fileName1 = file[file.length - 1];
                    URL url = new URL(makeBillOfLadingDO.getImgUrl().replaceAll(" ", "%20"));
                    pathList.add(fileName1);
                    inputStreams.add(url.openStream());
                }
            }
        }
        if (inputStreams.size() > 0) {
            ZipUtil.zip(checkFile, pathList.stream().toArray(String[]::new), inputStreams.stream().toArray(InputStream[]::new));
        } else {
            throw exception(HAVE_NOT_LADING);
        }
    }

    @Override
    public MakeBillOfLadingDO getInProcessing(Long orderId) {
        MakeBillOfLadingDO makeBillOfLadingDO = makeBillOfLadingMapper.selectOne(new LambdaQueryWrapperX<MakeBillOfLadingDO>().eq(MakeBillOfLadingDO::getOrderId, orderId)
                .eq(MakeBillOfLadingDO::getStatus, 1));
        return makeBillOfLadingDO;
    }

    @Override
    public void updateMakeBillOfLadingUrl(MakeBillOfLadingUpdateReqVO updateReqVO) {
        // 校验存在
        this.validateMakeBillOfLadingExists(updateReqVO.getId());
        // 更新
        MakeBillOfLadingDO updateObj = new MakeBillOfLadingDO();
        updateObj.setId(updateReqVO.getId());
        updateObj.setImgUrl(updateReqVO.getImgUrl());
        makeBillOfLadingMapper.updateById(updateObj);
    }

    @Override
    public void clearOrderBillLadingByOrderIds(Collection<Long> orderIds) {
        remove(new LambdaQueryWrapperX<MakeBillOfLadingDO>()
                .in(MakeBillOfLadingDO::getOrderId, orderIds)
        );
    }

    @Override
    public Map<String, Object> makeAirBillOfLading(Long orderId, Long shipmentId) throws Exception {
        List<CurrencyDO> currencyList = currencyService.getCurrencyList();
        Map<Integer, String> currencyMap = currencyList.stream().collect(Collectors.toMap(CurrencyDO::getId, CurrencyDO::getTitleEn, (key1, key2) -> key2));
        Map<Integer, String> currencyFuhaoMap = currencyList.stream().collect(Collectors.toMap(CurrencyDO::getId, CurrencyDO::getFuhao, (key1, key2) -> key2));
        Map<String, BigDecimal> totalFeeMap = new HashMap();
        Map<String, Object> map = new HashMap<>(4);
        Map<String, Object> templateMap = new HashMap<>();
        Map<String, Object> orderInfoMap = new HashMap<>();
        OrderBackInfoDto info = orderQueryService.info(orderId);
        if (info.getAbnormalState() != 0 || info.getAuditType() != 0) {
            throw exception(ORDER_EXCEPTION_OR_PROCESSING_ERROR);
        }
        CustomerDO customer = customerService.getCustomer(info.getCustomerId());
        //订单基本信息
        orderInfoMap.put("consignee", info.getConsigneeVO().getName());
        orderInfoMap.put("consigneePhone", "+" + info.getConsigneeVO().getCountryCode() + info.getConsigneeVO().getPhone());
        orderInfoMap.put("consignor", info.getConsignorVO().getName());
        orderInfoMap.put("consignorPhone", "+" + info.getConsignorVO().getCountryCode() + info.getConsignorVO().getPhone());
        if (info.getDrawee() == 1) { //订单付款人为发货人
            String shipperName = getShipperNameAndConsignee(info, 1, orderInfoMap);
            orderInfoMap.put("consignor", shipperName);
        } else if (info.getDrawee() == 2) { //订单付款人为收货人
            String consigneeName = getShipperNameAndConsignee(info, 2, orderInfoMap);
            orderInfoMap.put("consignee", consigneeName);
        }
        orderInfoMap.put("orderNo", info.getOrderNo());
        orderInfoMap.put("plNo", info.getTidanNo());
        LogisticsInfoDto startInfoAndDestInfoByLineId = warehouseLineMapper.getStartInfoAndDestInfoByLineId(info.getLineId());
        orderInfoMap.put("objectiveName", startInfoAndDestInfoByLineId.getDestTitleEn());
        if (info.getTransportId() == 3) {
            BoxBookAirDO boxBookAirDO = boxBookAirService.getOne(new LambdaQueryWrapperX<BoxBookAirDO>().eq(BoxBookAirDO::getShipmentId, shipmentId).orderByDesc(BaseDO::getCreateTime).last(" limit 1"));
            orderInfoMap.put("zgDate", DateUtils.formatDate(boxBookAirDO.getFlyTime()));
        } else {
            BoxBookSeaDO boxBookSeaDO = boxBookSeaService.getOne(new LambdaQueryWrapperX<BoxBookSeaDO>()
                    .eq(BoxBookSeaDO::getShipmentId, shipmentId).orderByDesc(BaseDO::getCreateTime).last(" limit 1"));
            orderInfoMap.put("zgDate", DateUtils.formatDate(boxBookSeaDO.getSailTime()));
        }
        templateMap.put("orderInfo", orderInfoMap);//订单基本信息
        BoxPreloadGoodsQueryVO boxPreloadGoodsQueryVO = new BoxPreloadGoodsQueryVO();
        boxPreloadGoodsQueryVO.setShipmentId(shipmentId);
        boxPreloadGoodsQueryVO.setOrderId(orderId);
        List<BoxPreloadGoodsDO> boxPreloadGoodsList = boxPreloadGoodsService.getBoxPreloadGoodsList(boxPreloadGoodsQueryVO);
        List<Long> orderItemIds = boxPreloadGoodsList.stream().map(BoxPreloadGoodsDO::getOrderItemId).collect(Collectors.toList());
        List<OrderItemDO> orderItemVOList = orderItemService.getOrderItemList(orderItemIds);
        AtomicInteger atomicInteger = new AtomicInteger(1);
        Map<String, Object> totalItemMap = new HashMap<>();
        List<Map<String, Object>> dataList = orderItemVOList.stream().filter(item -> item.getWarehouseInInfoVO() != null).map(item -> {
            Map<String, Object> paramMap = new HashMap<>();
            //订单项
            paramMap.put("index", atomicInteger.getAndIncrement());
            paramMap.put("mark", info.getMarks());
            paramMap.put("desc", item.getProdTitleEn());
            paramMap.put("num", item.getWarehouseInInfoVO().getCartonsNum());
            paramMap.put("num1", item.getWarehouseInInfoVO().getCartonsNum());
            paramMap.put("volume", item.getWarehouseInInfoVO().getWeight());
            paramMap.put("weight", Objects.nonNull(item.getChargeWeight()) && item.getChargeWeight().compareTo(item.getMinMeteringWeight()) > 0 ? item.getChargeWeight() : item.getMinMeteringWeight());
            if (item.getSeaFreightCurrency() != 1) {// 运费固定为美元，其他币种转换为美元
                BigDecimal seaFreight = changeAmountToDestCurrency(item.getSeaFreightCurrency().longValue(), 1L, item.getOneSeaFreight());
                paramMap.put("seaFreight", seaFreight);
            } else {
                paramMap.put("seaFreight", item.getOneSeaFreight());
            }


            if (item.getOneClearanceFreight().compareTo(BigDecimal.ZERO) == 0) {
                paramMap.put("clearanceFreight", "0");
            } else {
                if (info.getObjectiveVO().getObjectiveCountryId().intValue() == 4175) {//EC037:清关费，加纳为美元，科特迪瓦位西非法郎，其他国家统一为奈拉，非对应币种需要转换
                    if (item.getClearanceFreightCurrency() != 1) {
                        BigDecimal clearanceFreight = changeAmountToDestCurrency(item.getClearanceFreightCurrency().longValue(), 1L, item.getOneClearanceFreight());
                        paramMap.put("clearanceFreight", clearanceFreight);
                    } else {
                        paramMap.put("clearanceFreight", item.getOneClearanceFreight());
                    }
                } else if (info.getObjectiveVO().getObjectiveCountryId().intValue() == 4191) {
                    if (item.getClearanceFreightCurrency() != 6) {
                        BigDecimal clearanceFreight = changeAmountToDestCurrency(item.getClearanceFreightCurrency().longValue(), 6L, item.getOneClearanceFreight());
                        paramMap.put("clearanceFreight", clearanceFreight);
                    } else {
                        paramMap.put("clearanceFreight", item.getOneClearanceFreight());
                    }
                } else {
                    if (item.getClearanceFreightCurrency() != 2) {
                        BigDecimal clearanceFreight = changeAmountToDestCurrency(item.getClearanceFreightCurrency().longValue(), 2L, item.getOneClearanceFreight());
                        paramMap.put("clearanceFreight", clearanceFreight);
                    } else {
                        paramMap.put("clearanceFreight", item.getOneClearanceFreight());
                    }
                }
            }


            return paramMap;
        }).collect(Collectors.toList());
        //订单项合计
        int totalNum = orderItemVOList.stream().filter(item -> item.getWarehouseInInfoVO() != null).mapToInt(item -> item.getWarehouseInInfoVO().getCartonsNum()).sum();
        BigDecimal totalVolume = BigDecimal.ZERO;
        BigDecimal totalWeight = BigDecimal.ZERO;
        for (OrderItemDO orderItemDO : orderItemVOList) {
            if (orderItemDO.getWarehouseInInfoVO() != null) {
                totalVolume = totalVolume.add(orderItemDO.getWarehouseInInfoVO().getWeight());
                if (Objects.nonNull(orderItemDO.getChargeWeight()) && orderItemDO.getChargeWeight().compareTo(orderItemDO.getMinMeteringWeight()) > 0) {
                    totalWeight = totalWeight.add(orderItemDO.getChargeWeight());
                } else {
                    totalWeight = totalWeight.add(orderItemDO.getMinMeteringWeight());
                }
            }
        }
        StringBuffer seaStringBuffer = getStringBuffer(totalFeeMap, orderItemIds, 1);//运费
        StringBuffer clearanceStringBuffer = getStringBuffer(totalFeeMap, orderItemIds, 2);//清关费
        totalItemMap.put("totalNum", totalNum);
        totalItemMap.put("totalVolume", totalVolume);
        totalItemMap.put("totalWeight", totalWeight);
        totalItemMap.put("totalSeaFreight", seaStringBuffer.length() == 0 ? "" : seaStringBuffer.deleteCharAt(seaStringBuffer.length() - 1));
        totalItemMap.put("totalClearanceFreight", clearanceStringBuffer.length() == 0 ? "" : clearanceStringBuffer.deleteCharAt(clearanceStringBuffer.length() - 1));
        templateMap.put("totalItemMap", totalItemMap);//订单项总计
        templateMap.put("dataList", dataList);//订单项

        //其他费用
        List<ReceivableBackVO> receivableListByOrder = receivableService.getReceivableListByOrderId(orderId);
        List<Map<String, Object>> otherFeeList = receivableListByOrder.stream().filter(item -> item.getFeeSource() != 1).map(item -> {
            Map<String, Object> otherFeeMap = new HashMap<>();
            DictDataRespDTO receivable_fee_type = DictFrameworkUtils.getDictDataFromCache("receivable_fee_type", String.valueOf(item.getFeeType()));
            otherFeeMap.put("name", receivable_fee_type.getLabel() + "(" + receivable_fee_type.getLabelEn() + ")");
            long realClearanceFreightCurrency = 2L;
            if (info.getObjectiveVO().getObjectiveCountryId().intValue() == 4175) {
                realClearanceFreightCurrency = 1L;
            } else if (info.getObjectiveVO().getObjectiveCountryId().intValue() == 4191) {
                realClearanceFreightCurrency = 6L;
            }
            if (item.getCurrencyId().longValue() == realClearanceFreightCurrency) {
                otherFeeMap.put("amount2", item.getTotalAmount());
            } else {
                if (item.getCurrencyId().intValue() == 1) {
                    otherFeeMap.put("amount1", item.getTotalAmount());
                } else {
                    BigDecimal otherFeeChanged = changeAmountToDestCurrency(item.getCurrencyId(), 1L, item.getTotalAmount());
                    otherFeeChanged = otherFeeChanged.setScale(0, RoundingMode.HALF_UP);
                    otherFeeMap.put("amount1", otherFeeChanged);
                }
            }
            if (item.getCurrencyId() != null) {
                if (totalFeeMap.get(String.valueOf(item.getCurrencyId())) == null) {
                    totalFeeMap.put(String.valueOf(item.getCurrencyId()), item.getTotalAmount());
                } else {
                    totalFeeMap.put(String.valueOf(item.getCurrencyId()), totalFeeMap.get(String.valueOf(item.getCurrencyId())).add(item.getTotalAmount()));
                }
            }
            return otherFeeMap;
        }).collect(Collectors.toList());

        templateMap.put("otherFeeList", otherFeeList);//其他费用
        Map<String, Object> worthMap = new HashMap<>();
        worthMap.put("totalWorth", info.getCostVO().getTotalWorth() + "RMB");
        worthMap.put("insuranceFee", info.getCostVO().getInsuranceFee());
        worthMap.put("insuranceFeeCurrency", currencyMap.get(info.getCostVO().getInsuranceCurrencyId().intValue()));
        templateMap.put("worthMap", worthMap);//货值和保价费
        BigDecimal bigDecimal = totalFeeMap.get(String.valueOf(info.getCostVO().getInsuranceCurrencyId()));//保价费默认美元
        if (bigDecimal == null) {
            totalFeeMap.put(String.valueOf(info.getCostVO().getInsuranceCurrencyId()), info.getCostVO().getInsuranceFee());
        } else {
            totalFeeMap.put(String.valueOf(info.getCostVO().getInsuranceCurrencyId()), bigDecimal.add(info.getCostVO().getInsuranceFee()));
        }

        //空运预付 start
        List<ReceivableOrderPayedFeeTypeVO> payedFeeTypeVOList = receivableService.getPayedMoneyByFeeType(orderId);
        List<ReceivableOrderPayedFeeTypeVO> partCollectionTypeList = payedFeeTypeVOList.stream().filter(i -> (i.getCollectionType() == 1 || i.getCollectionType() == 2 || i.getCollectionType() == 3) && i.getReceiptId() != null).collect(Collectors.toList());
        partCollectionTypeList.stream().forEach(i -> {
            long realClearanceFreightCurrency = 2L;
            if (info.getObjectiveVO().getObjectiveCountryId().intValue() == 4175) {
                realClearanceFreightCurrency = 1L;
            } else if (info.getObjectiveVO().getObjectiveCountryId().intValue() == 4191) {
                realClearanceFreightCurrency = 6L;
            }
            if (i.getCurrencyId() != realClearanceFreightCurrency && i.getCurrencyId() != 1) {
                BigDecimal payedAmount = changeAmountToDestCurrency(i.getCurrencyId(), 1L, i.getPayedAmount());
                i.setCurrencyId(1L);
                i.setPayedAmount(payedAmount);
            }
        });

        Map<String, Map<String, BigDecimal>> prePayedMapChanged = new HashMap<>();
        Map<Integer, Map<Long, BigDecimal>> prePayedMap = partCollectionTypeList.stream().collect(Collectors.groupingBy(ReceivableOrderPayedFeeTypeVO::getCollectionType, Collectors.groupingBy(ReceivableOrderPayedFeeTypeVO::getCurrencyId, Collectors.reducing(BigDecimal.ZERO, ReceivableOrderPayedFeeTypeVO::getPayedAmount, BigDecimal::add))));
        for (Map.Entry<Integer, Map<Long, BigDecimal>> entry : prePayedMap.entrySet()) {
            Map<String, BigDecimal> innerMap = new HashMap<>();
            for (Map.Entry<Long, BigDecimal> entry1 : entry.getValue().entrySet()) {
                if (entry1.getKey().longValue() == 1L) {
                    innerMap.put("leftCell", entry1.getValue());
                } else {
                    innerMap.put("rightCell", entry1.getValue());
                }
            }
            prePayedMapChanged.put(DictFrameworkUtils.getDictDataFromCache("payment_type", String.valueOf(entry.getKey())).getLabelEn(), innerMap);
        }
        templateMap.put("prePayedMap", prePayedMapChanged);

        //空运预付 end

        //总金额 start
        //总金额左边先加上运费
        BigDecimal totalLeft = new BigDecimal("0");
        BigDecimal totalRight = new BigDecimal("0");
        StringBuffer stringBuffer = new StringBuffer();
        List<ReceivableOrderPayedFeeTypeVO> receivableYunFeiList = payedFeeTypeVOList.stream().filter(i -> i.getFeeType() == 1).collect(Collectors.toList());
        for (ReceivableOrderPayedFeeTypeVO i : receivableYunFeiList) {
            if (i.getCurrencyId() != 1L) {
                totalLeft = totalLeft.add(changeAmountToDestCurrency(i.getCurrencyId(), 1L, i.getTotalAmount()));
            } else {
                totalLeft = totalLeft.add(i.getTotalAmount());
            }
        }
        long realClearanceFreightCurrency = 2L;
        if (info.getObjectiveVO().getObjectiveCountryId().intValue() == 4175) {
            realClearanceFreightCurrency = 1L;
        } else if (info.getObjectiveVO().getObjectiveCountryId().intValue() == 4191) {
            realClearanceFreightCurrency = 6L;
        }
        //总金额右边再加上清关费
        List<ReceivableOrderPayedFeeTypeVO> receivableQingGuanFeiList = payedFeeTypeVOList.stream().filter(i -> i.getFeeType() == 2).collect(Collectors.toList());
        for (ReceivableOrderPayedFeeTypeVO i : receivableQingGuanFeiList) {
            if (i.getCurrencyId() != realClearanceFreightCurrency) {
                totalRight = totalRight.add(changeAmountToDestCurrency(i.getCurrencyId(), realClearanceFreightCurrency, i.getTotalAmount()));
            } else {
                totalRight = totalRight.add(i.getTotalAmount());
            }
        }
        //总金额加上保价费
        if (info.getCostVO().getInsuranceCurrencyId().longValue() == 1L) {
            totalLeft = totalLeft.add(info.getCostVO().getInsuranceFee());
        } else if (info.getCostVO().getInsuranceCurrencyId().longValue() == realClearanceFreightCurrency) {
            totalRight = totalRight.add(info.getCostVO().getInsuranceFee());
        } else {
            //TODO 和总金额拼起来展示？还是转换成美元加进去？
        }
        //总金额加上额外费用
        for (Map<String, Object> stringObjectMap : otherFeeList) {
            if (stringObjectMap.get("amount1") != null) {
                totalLeft = totalLeft.add((BigDecimal) stringObjectMap.get("amount1"));
            }
            if (stringObjectMap.get("amount2") != null) {
                totalRight = totalRight.add((BigDecimal) stringObjectMap.get("amount2"));
            }
        }
        //总金额减去预付金额
        for (Map.Entry<String, Map<String, BigDecimal>> entry : prePayedMapChanged.entrySet()) {
            Map<String, BigDecimal> value = entry.getValue();
            if (value.get("leftCell") != null) {
                totalLeft = totalLeft.subtract(value.get("leftCell"));
            }
            if (value.get("rightCell") != null) {
                totalRight = totalRight.subtract(value.get("rightCell"));
            }
        }
        //总金额 end
        templateMap.put("totalFeeLeft", totalLeft);//总费用
        templateMap.put("totalFeeRight", totalRight);//总费用
//        Map<Long, BigDecimal> payedAmount = new HashMap<>();
//        if (payedFeeTypeVOList != null) {
//            payedAmount = payedFeeTypeVOList.stream().collect(Collectors.groupingBy(ReceivableOrderPayedFeeTypeVO::getCurrencyId, Collectors.reducing(BigDecimal.ZERO, ReceivableOrderPayedFeeTypeVO::getPayedAmount, BigDecimal::add)));
//        }
//        if (totalFeeMap.size() > 0) {
//            for (Map.Entry<String, BigDecimal> item : totalFeeMap.entrySet()) {
//                BigDecimal money = item.getValue();
//                if (payedAmount.get(Long.valueOf(item.getKey())) != null) {
//                    money = item.getValue().subtract(payedAmount.get(Long.valueOf(item.getKey())));
//                }
//                money = money.setScale(0, RoundingMode.HALF_UP);
//                stringBuffer.append(money + currencyMap.get(Integer.valueOf(item.getKey()))).append(" ");
//            }
//        }
//        templateMap.put("totalFee", stringBuffer.toString());//总费用
        LadingTemplateDO ladingTemplateByLineId = ladingTemplateService.getLadingTemplateByLineId(info.getLineId());
        if (ladingTemplateByLineId != null) {
            if (StringUtils.isNotBlank(ladingTemplateByLineId.getAccount())) {
                templateMap.put("acctList", JSONArray.parseArray(ladingTemplateByLineId.getAccount()));
            } else {
                templateMap.put("acctList", new ArrayList<>());
            }
        } else {
            throw exception(LADING_TEMPLATE_NOT_SET);
        }
        //调用工具类抓取html代码
        String template = "";
        if (!info.getDisplayBillLadingPrice()) {
            template = FreeMarkerUtil.parseTemplate("/templates/", "airTemplateNoFee.ftl", templateMap);
        } else {
            template = FreeMarkerUtil.parseTemplate("/templates/", "airTemplate.ftl", templateMap);
        }
        map.put("orderInfo", template);
        map.put("ladingTemplate", ladingTemplateByLineId);
        return map;
    }

    private void makeFile(MakeBillOfLadingDO lading) throws Exception {
        String billContent = lading.getBillContent().replace("white-space: nowrap;", "width:340px;white-space: nowrap;");
        OrderDO orderDO = orderService.getById(lading.getOrderId());
        String head = "<!DOCTYPE html>\n" +
                "<html lang=\"en\">\n" +
                "\n" +
                "<head>\n" +
                "    <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"/>\n" +
                "\n" +
                "    <title>" + orderDO.getTidanNo() + "提货单</title>\n" +
                "    <style type=\"text/css\">\n" +
//                "\t\t.subs {\n" +
//                "\t\t\ttext-align: center;\n" +
//                "\t\t\tpadding-bottom: 30px;\n" +
//                "\t\t\tpadding-top: 10px;\n" +
//                "\t\t}\n" +
//                "\n" +
//                "\t\t.subs input[type='button'] {\n" +
//                "\t\t\twidth: 50px;\n" +
//                "\t\t\theight: 30px;\n" +
//                "\t\t\tbackground: #4e9cdd;\n" +
//                "\t\t\tborder: none;\n" +
//                "\t\t\tborder-radius: 5px;\n" +
//                "\t\t\tmargin-right: 10px;\n" +
//                "\t\t\tfont-size: 16px;\n" +
//                "\t\t\tcursor: pointer;\n" +
//                "\t\t\tcolor: #fff;\n" +
//                "\t\t}\n" +
                "\t</style>\n" +
                "</head>\n" +
                "<body>";
        String foot = "</body>\n" +
                "</html>";
        //设置打印后pdf的格式
        Document document = new Document(PageSize.A4);
//            File file = new File("D://18.pdf");
        File file = new File(prePath + File.separator + orderDO.getOrderNo() + ".pdf");
        OutputStream outputStream = new FileOutputStream(file);
        PdfWriter pdfWriter = PdfWriter.getInstance(document, outputStream);// outputStream可以自己指定位置或者是HttpServletResponse得到的输出流
        pdfWriter.setTagged();
        document.open();
        ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream((head + billContent + foot).getBytes());
        XMLWorkerHelper.getInstance().parseXHtml(pdfWriter, document, byteArrayInputStream, Charset.defaultCharset());
        document.close();
        byteArrayInputStream.close();
        outputStream.flush();
        outputStream.close();
    }

    private BigDecimal changeAmountToDestCurrency(Long fromCurrencyId, Long toCurrencyId, BigDecimal fromAmount) {
        BigDecimal destAmount = BigDecimal.ZERO;
        ExchangeRateRespDTO currencyRate = currencyApi.getCurrencyRate(fromCurrencyId, toCurrencyId);
        destAmount = fromAmount.multiply(currencyRate.getCurrencyRate());
        return destAmount;
    }
}
